/*
 *
 * *********************************************
 * 
 *     main/icqim
 *      -    
 *  UIN (   centericq)
 * 
 * *********************************************
 * 
 * $Author: morsov $
 * $Date: 2004/10/21 12:28:43 $
 * $Revision: 2.0.2.3 $
 * $Name:  $
 *
 * 
 */

#include "icqalerts.h"


//  
// 
MYSQL conn;
MYSQL_ROW row;
MYSQL_RES *result;
char sql[QUERY_LENGTH];
char sql2[QUERY_LENGTH];
char number[31];
FILE *LOG;

// 
int msg2log(int);
void sigcatch(int);


//  -
int main(int argc, char **argv)
{	
	// 
	FILE *CICQ;
	char *command = (char *) malloc(sizeof(char) * (STRING_LENGTH));
	int ret, id;
	
	//    
	signal(SIGTERM, &sigcatch);
	signal(SIGINT, &sigcatch);
	signal(SIGQUIT, &sigcatch);
	signal(SIGHUP, &sigcatch);
	


	//  
	if ( (LOG=fopen(LOGFILE, "a")) == NULL ) {
		printf ("icqalerts (c) Morsov\n");
		printf ("Can't open log file /var/log/icqalerts.log.\n"
				"program terminate.\n");
		exit(-1);
	} else {
		fclose(LOG);
		msg2log(START);
	}

	//   mysql 
	mysql_init(&conn);

	if (!mysql_real_connect(&conn, MYSQLHOST, NULL, NULL, "main", 0, NULL, 0)) {
		exit(msg2log(DBERROR));
	}

	sprintf(sql, "SELECT id, type, num, mtext FROM icqim ORDER BY id LIMIT 1");
	
	while (1) {
		//    centericq
		if ( (ret=system("ps -A|grep -q centericq")) != 0) {
			msg2log(NOCICQ);
			sleep(15);
			continue;
		}
		if ( mysql_query(&conn, sql) != -1 ) {
			result = mysql_store_result(&conn);
			if (mysql_num_rows(result) == 0)
				mysql_free_result(result);
			else {
				if ( row = mysql_fetch_row(result) ) {
					id=atoi(row[0]);
					strcpy(number, row[2]);
					if ( !strcmp(row[1],"msg") )
						sprintf(command, "centericq -s %s -p icq -t %s >/dev/null", row[1], row[2]);
					else
						sprintf(command, "centericq -s %s -p icq -n %s >/dev/null", row[1], row[2]);
					if ( (CICQ=popen(command, "w")) == NULL )
						msg2log(PIPEERROR);
					else {
						fprintf(CICQ, "%s", row[3]);
						pclose(CICQ);
						if  (!strcmp(row[1],"msg") )
							msg2log(MSGSEND);
						else
							msg2log(SMSSEND);
					}
					mysql_free_result(result);
					//     
					sprintf(sql2, "DELETE FROM icqim WHERE id=%d", id);
					if ( mysql_query(&conn, sql2) != 0 )
						msg2log(SQLERROR);
				}
			}
			sleep(10);
		} else 
				msg2log(SQLERROR);
		sleep(10);
	} // end of while(1)
}


	int msg2log(int errcode)
{
	LOG=fopen(LOGFILE, "a");

	if (errcode == DBERROR)
		fprintf(LOG, "[%s] - Error %d: %s\n", get_datetime(RUSDTIME), errcode, mysql_error(&conn));
	if (errcode == NOCICQ)
		fprintf(LOG, "[%s] - Error %d: No centericq process present\n", get_datetime(RUSDTIME), errcode);
	if (errcode == PIPEERROR)
		fprintf(LOG, "[%s] - Error %d: Can't open pipe to centericq\n", get_datetime(RUSDTIME), errcode);
	if (errcode == SQLERROR)
		fprintf(LOG, "[%s] - Error %d: %s\n", get_datetime(RUSDTIME), errcode, mysql_error(&conn));
	if (errcode == START)
		fprintf(LOG, "[%s] - Start (icqalerts $Revision: 2.0.2.3 $)\n", get_datetime(RUSDTIME));
	if (errcode == STOP)
		fprintf(LOG, "[%s] - Stop\n", get_datetime(RUSDTIME));
	if (errcode == MSGSEND)
		fprintf(LOG, "[%s] - Message send to ICQ UIN %s\n", get_datetime(RUSDTIME), number);
	if (errcode == SMSSEND)
		fprintf(LOG, "[%s] - Message send to SMS number %s\n", get_datetime(RUSDTIME), number);

	fclose(LOG);
}

void sigcatch(int n)
{
	mysql_close(&conn);
	msg2log(STOP);
	fclose(LOG);
	exit(0);
}

