#include <mysql.h>
#define START_MSG "Content-Type: text/html\n\n"
#define GET_MSG "     GET"
#define INFO_MSG "  "
#define MAX_ENTRIES 20

extern const char *URL;
extern const char *URLS;

typedef struct {
	char name[30];
	char val[256];
} entry_get;

typedef struct {
	char *name;
	char *val;
} entry_post;

extern char  *makeword(char *line, char stop);
extern char  *fmakeword(FILE *f, char stop, int *len);
extern char  x2c(char *what);
extern void  unescape_url(char *url);
extern void  plustospace(char *str);
extern MYSQL db_init(char *);
extern void  db_close(MYSQL *);
extern void  Error(char *);
extern void  DBError(MYSQL *);
extern void  SendQuery(MYSQL *, char *);
extern char  *mysql_date(time_t);
extern char  *mysql_time(time_t);
extern int getvalget(entry_get *, char *);
extern int getvalpost(entry_post *, char *);
extern int print_html_head(char *);
extern int print_common_header();
extern int print_common_footer();
extern int print_common_800_header();
extern int print_common_800_footer();
extern void errormsg (char *, int);
extern void dberrormsg(MYSQL *, int);
void dateselector();
